/*
    likelihood.c
    $Id: likelihood.c,v 1.2 2013/01/05 06:33:55 daichi Exp $

 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "feature.h"
#include "likelihood.h"

double
um_ppl (document *data, double **p, double *lambda, double **beta, int nmixtures)
{
	document *dp;
	double n = 0;
	int j;

	for (dp = data; (dp->len) != -1; dp++)
		for (j = 0; j < dp->len; j++)
			n += dp->cnt[j];

	return exp (- um_lik(data, p, lambda, beta, nmixtures) / n);
}
	
double
um_lik (document *data, double **p, double *lambda, double **beta, int nmixtures)
{
	document *dp;
	double lik = 0;
	int i, j, k;

	for (dp = data, i = 0; (dp->len) != -1; dp++, i++)
	{
		for (k = 0; k < nmixtures; k++)
		{
			lik += log (lambda[k]);
			for (j = 0; j < dp->len; j++)
			{
				lik += p[i][k] * dp->cnt[j] * log (beta[k][dp->id[j]]);
			}
		}
	}

	return lik;
}


	
